Bug 1852009 (CVE-2020-14308) - CVE-2020-14308 grub2: grub_malloc does not validate allocation size allowing for arithmetic overflow and subsequent heap-based buffer overflow
Summary: CVE-2020-14308 grub2: grub_malloc does not validate allocation size allowing ...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2020-14308
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1853694 1853699 1863017 1853688 1853689 1853690 1853691 1853692 1853693 1853695 1853696 1853697 1853698
Blocks: 1852004
TreeView+ depends on / blocked
 
Reported: 2020-06-29 15:23 UTC by Marco Benatto
Modified: 2020-08-07 19:40 UTC (History)
5 users (show)

Fixed In Version: grub 2.06
Doc Type: If docs needed, set a value
Doc Text:
In current grub2 versions as shipped with Red Hat Enterprise Linux 7 and 8, the grub memory allocator doesn't check for possible arithmetic overflows on the requested allocation size. This leads the function to return invalid memory allocations which can be further used to cause possible integrity, confidentiality and availability impacts during the boot process.
Clone Of:
Environment:
Last Closed: 2020-07-29 19:27:46 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:3216 None None None 2020-07-29 18:30:38 UTC
Red Hat Product Errata RHSA-2020:3217 None None None 2020-07-29 19:34:02 UTC
Red Hat Product Errata RHSA-2020:3223 None None None 2020-07-29 19:37:47 UTC
Red Hat Product Errata RHSA-2020:3227 None None None 2020-07-29 20:14:44 UTC
Red Hat Product Errata RHSA-2020:3271 None None None 2020-08-03 11:52:26 UTC
Red Hat Product Errata RHSA-2020:3273 None None None 2020-08-03 10:57:02 UTC
Red Hat Product Errata RHSA-2020:3274 None None None 2020-08-03 12:05:50 UTC
Red Hat Product Errata RHSA-2020:3275 None None None 2020-08-03 11:13:59 UTC
Red Hat Product Errata RHSA-2020:3276 None None None 2020-08-03 12:02:21 UTC

Description Marco Benatto 2020-06-29 15:23:25 UTC
Currently grub_malloc() function and related memory infrastructure underlying it doesn't fully validate the allocation size. This can lead
to arithmetic overflows leading to invalid memory allocations, which can be leverage to heap-based overflows in several code paths.

Comment 4 Marco Benatto 2020-07-03 15:04:30 UTC
In the current grub versions, grub_malloc() malloc function doesn't validate if the allocation size may overflow the maximum type representation. This leads grub_malloc() to return invalid allocations, an attacker may leverage causing memory corruption leading to possible integrity, confidentiality and availability impacts. To be able to exploit this the attacker needs local privileged or physical access to the machine.

Comment 5 Marco Benatto 2020-07-07 13:41:24 UTC
Acknowledgments:

Name: Chris Coulson (Ubuntu Security Team)

Comment 8 errata-xmlrpc 2020-07-29 18:30:35 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2020:3216 https://access.redhat.com/errata/RHSA-2020:3216

Comment 9 Product Security DevOps Team 2020-07-29 19:27:46 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2020-14308

Comment 10 errata-xmlrpc 2020-07-29 19:34:00 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2020:3217 https://access.redhat.com/errata/RHSA-2020:3217

Comment 11 errata-xmlrpc 2020-07-29 19:37:44 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.1 Extended Update Support

Via RHSA-2020:3223 https://access.redhat.com/errata/RHSA-2020:3223

Comment 12 errata-xmlrpc 2020-07-29 20:14:42 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.0 Update Services for SAP Solutions

Via RHSA-2020:3227 https://access.redhat.com/errata/RHSA-2020:3227

Comment 13 errata-xmlrpc 2020-08-03 10:57:00 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.2 Advanced Update Support

Via RHSA-2020:3273 https://access.redhat.com/errata/RHSA-2020:3273

Comment 14 errata-xmlrpc 2020-08-03 11:13:56 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.4 Advanced Update Support
  Red Hat Enterprise Linux 7.4 Update Services for SAP Solutions
  Red Hat Enterprise Linux 7.4 Telco Extended Update Support

Via RHSA-2020:3275 https://access.redhat.com/errata/RHSA-2020:3275

Comment 15 errata-xmlrpc 2020-08-03 11:52:22 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.6 Extended Update Support

Via RHSA-2020:3271 https://access.redhat.com/errata/RHSA-2020:3271

Comment 16 errata-xmlrpc 2020-08-03 12:02:15 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.3 Advanced Update Support
  Red Hat Enterprise Linux 7.3 Update Services for SAP Solutions
  Red Hat Enterprise Linux 7.3 Telco Extended Update Support

Via RHSA-2020:3276 https://access.redhat.com/errata/RHSA-2020:3276

Comment 17 errata-xmlrpc 2020-08-03 12:05:47 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.7 Extended Update Support

Via RHSA-2020:3274 https://access.redhat.com/errata/RHSA-2020:3274

Comment 18 Marco Benatto 2020-08-03 13:45:23 UTC
Created grub2 tracking bugs for this issue:

Affects: fedora-all [bug 1863017]


Note You need to log in before you can comment on or make changes to this bug.